#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "terms.h"
#include "ga.h"

extern int db[10];

List diags_info=0;

static void collect_prm(List *, List *);
static int f_wrt_term(FILE *file, Term T, List l_v, List l_f);

List all_eps_l=0;

static List add_new(List l, Atom p)
{
	if(ListMember(l,p))
		return l;
	return AppendLast(l,p);
}

extern Atom pmass[16];

static int eps_no=0;

static List add_new_cnv(List lc, Term c)
{
	List l1;
	for(l1=lc;l1;l1=ListTail(l1))
		if(EqualTerms(ListFirst(l1),c))
			return lc;
	return AppendLast(lc,CopyTerm(c));
}

static int cnv_cmp(Term c1, Term c2)
{
	return strcmp(AtomValue(CompoundArg2(c1)),AtomValue(CompoundArg2(c2)));
}

static char lu_up_cbuf[16];

static char *lu_up(List *l, Term t)
{
	List l1;
	
	if(CompoundArity(t)==2)
	{
		char cbuf[16], *p;
		char c1,c2;
		int n1,n2;
		Atom a;
		
		for(l1=*l;l1;l1=ListTail(l1))
			if(EqualTerms(CompoundArg1(ListFirst(l1)),t))
				return AtomValue(CompoundArg2(ListFirst(l1)));
		
		p=AtomValue(CompoundArg1(t));
		c1=p[0];
		sscanf(p+1,"%d",&n1);
		if(n1>200) n1-=200-in_prt;
		if(n1>100) n1-=100;
		p=AtomValue(CompoundArg2(t));
		c2=p[0];
		sscanf(p+1,"%d",&n2);
		if(n2>200) n2-=200-in_prt;
		if(n2>100) n2-=100;
		sprintf(cbuf,"%c%d_%c%d",c1,n1,c2,n2);
		a=NewAtom(cbuf,0);
		*l=AppendLast(*l,MakeCompound2(OPR_MINUS,CopyTerm(t),a));
		return AtomValue(a);
	}
	if(CompoundArity(t)==1)
	{
		int i;
		i=0;
		for(l1=all_eps_l;l1;l1=ListTail(l1))
		{
			i++;
			if(EqualTerms(CompoundArg1(ListFirst(l1)),t))
			{
				sprintf(lu_up_cbuf,"EPS(%d)*(0,1)",i);
				return lu_up_cbuf;
			}
		}
		
		sprintf(lu_up_cbuf,"EPS(%d)*(0,1)",++eps_no);
		all_eps_l=AppendLast(all_eps_l,CopyTerm(t));
		return lu_up_cbuf;
	}
	puts("!!!!!!!!! Epsilon in output !!!!!!!!!!");
	WriteTerm(t);puts("");
	return "???";
}
		
int fort_out_d(void)
{
	FILE *fout;
	List u_p=0, u_cnv=0;
	List l;
	char cbuf[32];
	
	sprintf(cbuf,"f%05d.ff",diag_no);
	fout=fopen(cbuf,"w");
	if(fout==NULL)
	{
		printf("Error: can not open '%s' for writing.\n",cbuf);
		exit(0);
	}
	
	fprintf(fout,"      AMP1=0\n\n");
	
	fprintf(fout,"      ColFact=%d.\n",color_factor);
	fprintf(fout,"      SymFact=");
	fWriteTerm(fout,out_sym_fact);
	fprintf(fout,".\n      LooFact=");
	fWriteTerm(fout,loop_sym_fact);
	fprintf(fout,".\n      NumFact=%d./%d.\n",cf_num,cf_den);
	fprintf(fout,"      VarFact=");
	if(cf_sym==0)
		fprintf(fout,"1\n");
	else
	{
		int first=1;
		for(l=cf_sym;l;l=ListTail(l))
		{
			Term p;
			int po;
			p=ListFirst(l);
			po=IntegerValue(CompoundArg2(p));
			u_p=add_new(u_p,CompoundArg1(p));
			if(po<0)
				fprintf(fout,first?"1/":"/");
			if(!first && po>0)
				fprintf(fout,"*");
			if(po<0)
				po=-po;
			fWriteTerm(fout,CompoundArg1(p));
			if(po>1)
				fprintf(fout,"**%d",po);
			first=0;
		}
		fprintf(fout,"\n");
	}
		

	for(l=td_num;l;l=ListTail(l))
	{
		Term m2;
		List l1;
		m2=ListFirst(l);
		
		/*
		if(db[7])
			fprintf(fout,"C... "),fWriteTerm(fout,m2),fprintf(fout,"\n");
		*/
				
		fprintf(fout,"      AMP1=AMP1");
		if(CompoundArg2(m2)==0 && CompoundArgN(m2,3)==0)
		{
			fprintf(fout,"%+ld\n",IntegerValue(CompoundArg1(m2)));
			continue;
		}
		
		if(CompoundArg1(m2)==NewInteger(1))
			fprintf(fout,"+");
		else if(CompoundArg1(m2)==NewInteger(-1))
			fprintf(fout,"-");
		else
			fprintf(fout,"%+ld*",IntegerValue(CompoundArg1(m2)));
		
		for(l1=CompoundArg2(m2);l1;l1=ListTail(l1))
		{
			Term p;
			p=ListFirst(l1);
			u_p=add_new(u_p,CompoundArg1(p));
			fWriteTerm(fout,CompoundArg1(p));
			if(IntegerValue(CompoundArg2(p))>1)
				fprintf(fout,"**%ld",IntegerValue(CompoundArg2(p)));
			if(ListTail(l1) || CompoundArgN(m2,3))
				fprintf(fout,"*");
		}
		
		for(l1=CompoundArgN(m2,3);l1;l1=ListTail(l1))
		{
			Term p;
			p=ListFirst(l1);
			fprintf(fout,lu_up(&u_cnv,p));
			if(ListTail(l1))
				fprintf(fout,"*");
		}
		fprintf(fout,"\n");
	}
	
	for(l=td_prop;l;l=ListTail(l))
	{
		int i=0;
		fprintf(fout,"      PR=");
		if(is_empty_list(CompoundArg1(ListFirst(l))))
			fprintf(fout,"0\n");
		else
		{
			List l1;
			i=0;
			for(l1=CompoundArg1(ListFirst(l));l1;l1=ListTail(l1))
			{
				Term m2;
				i++;
				m2=ListFirst(l1);
				if(CompoundArg2(m2))
				{
					fprintf(fout,"-%s**2",
					AtomValue(CompoundArg1(ListFirst(CompoundArg2(m2)))));
					u_p=add_new(u_p,CompoundArg1(ListFirst(CompoundArg2(m2))));
				}
				else
				{
					int co;
					co=IntegerValue(CompoundArg1(m2));
					fprintf(fout,"%+d*%s",co,lu_up(&u_cnv,
							ListFirst(CompoundArgN(m2,3))));
				}
				if((i%5)==0 && ListTail(l1))
					fprintf(fout,"\n     >   ");
			}
		}
			if(CompoundArg2(ListFirst(l)))
			{
				i++;
				if((i%5)==0)
					fprintf(fout,"\n     >   ");
				fprintf(fout,"+%s**2",AtomValue(CompoundArg2(ListFirst(l))));
				u_p=add_new(u_p,CompoundArg2(ListFirst(l)));
			}
			if(CompoundArg2(ListFirst(l))&&CompoundArgN(ListFirst(l),3))
			{
				i++;
				if((i%5)==0)
					fprintf(fout,"\n     >   ");
				fprintf(fout,"+(0,1)*%s*%s",
						AtomValue(CompoundArg2(ListFirst(l))),
						AtomValue(CompoundArgN(ListFirst(l),3)));
				u_p=add_new(u_p,CompoundArgN(ListFirst(l),3));
			}
		fprintf(fout,"\n      AMP1=AMP1/PR\n");
	}
	
	if(db[7])
	{
		printf("Diagram %d.\nUsed parameters: ",diag_no);
		WriteTerm(u_p);puts("\nCnv:");DumpList(u_cnv);
	}
	
	
	
	{
		Term t;
		t=MakeCompound(A_I,5);
		SetCompoundArg(t,1,NewInteger(diag_no));
		SetCompoundArg(t,2,u_p);
		SetCompoundArg(t,3,u_cnv);
		SetCompoundArg(t,4,CopyTerm(color_str));
		SetCompoundArg(t,5,CopyTerm(td_prop));
		diags_info=AppendLast(diags_info,t);
	} 
	
	fprintf(fout,"      AMP1=AMP1*ColFact*SymFact*LooFact*NumFact*VarFact\n");
	fprintf(fout,"      AMP=AMP+AMP1\n\n      RETURN\n      END\n\n");

	fclose(fout);
	return 1;	
}

static int par_no(Atom p, List v, List f)
{
	int r;
	r=ListMember(v,p);
	if(r)
		return r;
	return ListMember(f,p)+ListLength(v);
}


int fort_out_a(void)
{
	FILE *fout;
	int i,j;
	
	List l, l_var=0, l_fun=0, l_cnv=0;
	
	for(i=1;i<=in_prt;i++)
		prtnm[i]=GetAtomProperty(prtnm[i],A_ANTI);
	
	collect_prm(&l_var, &l_fun);
	
	if(db[7])
	{
		printf("---------- Summary info on diagrams output ------\n");
		printf("Vars: "); WriteTerm(l_var);puts("");
		printf("Func: "); WriteTerm(l_fun);puts("");
	}
	
	fout=fopen("service.f","w");
	if(fout==NULL)
	{
		printf("Can't open 'service.f' for writing.\n");
		exit(0);
	}
	
	fprintf(fout,"************************************\n");
	fprintf(fout,"********* AmpLoop v. 2.0.0 *********\n");
	fprintf(fout,"************************************\n\n");
	fprintf(fout,"      FUNCTION NIN()\n");
	fprintf(fout,"         NIN=%d\n",in_prt);
	fprintf(fout,"      RETURN\n      END\n\n");
	fprintf(fout,"      FUNCTION NOUT()\n         NOUT=%d\n",out_prt);
	fprintf(fout,"      RETURN\n      END\n\n");
	fprintf(fout,"      FUNCTION NPRC()\n         NPRC=1\n");
	fprintf(fout,"      RETURN\n      END\n\n");
	fprintf(fout,"      FUNCTION LENR()\n         LENR=8\n");
	fprintf(fout,"      RETURN\n      END\n\n");
	fprintf(fout,"      FUNCTION PINF(NSUB,NPRTCL)\n");
	fprintf(fout,"      CHARACTER*6 PINF,NAMES(1,%d)\n",in_prt+out_prt);
	fprintf(fout,"      DATA ( NAMES(1,I),I=1,%d)/",in_prt+out_prt);
	for(i=1;i<=in_prt+out_prt;i++)
		fprintf(fout,"'%s'%c",AtomValue(prtnm[i]),i==in_prt+out_prt?'/':',');
	fprintf(fout,"\n      PINF=NAMES(NSUB,NPRTCL)\n");
	fprintf(fout,"      RETURN\n      END\n\n");
	
	fprintf(fout,"      FUNCTION NVAR()\n");
	fprintf(fout,"         NVAR=%d\n",ListLength(l_var));
	fprintf(fout,"      RETURN\n      END\n\n");
	fprintf(fout,"      FUNCTION NFUN()\n         NFUN=%d\n",ListLength(l_fun));
	fprintf(fout,"      RETURN\n      END\n\n");
	
	fprintf(fout,"      SUBROUTINE VINF(NUMVAR,NAME,VAL)\n");
	fprintf(fout,"      IMPLICIT DOUBLE PRECISION (A-H,O-Z)\n");
	fprintf(fout,"      DOUBLE PRECISION VAL\n");
	fprintf(fout,"      COMMON/VARS/A(%d)\n",ListLength(l_var)+ListLength(l_fun));
	fprintf(fout,"      CHARACTER*6 NAMES(%d),NAME\n",ListLength(l_var));
	fprintf(fout,"      SAVE\n      DATA NAMES/");

	j=ListLength(l_var);	
	for(i=1;i<=j;i++)
	{
		fprintf(fout,"'%s'",AtomValue(ListNth(l_var,i)));
		if(i!=j)
			fprintf(fout,",");
		else
			fprintf(fout,"/\n");
		if(i!=j && (i%7)==0)
			fprintf(fout,"\n     >");
	}
	
	fprintf(fout,"      IF (NUMVAR.GT.%d) RETURN\n",ListLength(l_var));
	fprintf(fout,"      NAME=NAMES(NUMVAR)\n      VAL=A(NUMVAR)\n");
	fprintf(fout,"      RETURN\n      END\n\n");
	
	fprintf(fout,"      SUBROUTINE ASGN(NUMVAR,VALNEW)\n");
	fprintf(fout,"      IMPLICIT DOUBLE PRECISION (A-H,O-Z)\n");
	fprintf(fout,"      DOUBLE PRECISION VALNEW\n");
	fprintf(fout,"      COMMON/VARS/A(%d)\n",ListLength(l_var)+ListLength(l_fun));
	fprintf(fout,"      SAVE\n");
	fprintf(fout,"      IF((NUMVAR.LT.1).OR.(NUMVAR.GT.%d)) RETURN\n",
			ListLength(l_var));
	fprintf(fout,"      A(NUMVAR)=VALNEW\n      RETURN\n      END\n\n");
	
	fprintf(fout,"      SUBROUTINE PMAS(NSUB,NPRTCL,VAL)\n");
	fprintf(fout,"      IMPLICIT DOUBLE PRECISION (A-H,O-Z)\n");
	fprintf(fout,"      DIMENSION NVALUE(1,%d)\n",in_prt+out_prt);
	fprintf(fout,"      COMMON/VARS/A(%d)\n",ListLength(l_var)+ListLength(l_fun));
	fprintf(fout,"      SAVE\n      DATA ( NVALUE(1,I),I=1,%d)/",
			in_prt+out_prt);
	for(i=1;i<=in_prt+out_prt;i++)
	{
		if(pmass[i]==0)
			fprintf(fout,"0");
		else
		{
			int pmp;
			pmp=ListMember(l_var,pmass[i]);
			if(pmp==0)
				pmp=ListMember(l_fun,pmass[i])+ListLength(l_var);
			fprintf(fout,"%d",pmp);
		}
		if(i==in_prt+out_prt)
			fprintf(fout,"/\n");
		else
			fprintf(fout,",");
	}
	fprintf(fout,"      N=NVALUE(NSUB,NPRTCL)\n");
	fprintf(fout,"      IF (N.GT.%d) CALL INIT\n",ListLength(l_var));
	fprintf(fout,"      IF (N.EQ.0)  THEN\n"); 
	fprintf(fout,"         VAL=0\n      ELSE\n");
	fprintf(fout,"         VAL=A(N)\n      ENDIF\n");
	fprintf(fout,"      RETURN\n      END\n\n");

	fprintf(fout,"      SUBROUTINE INIT\n");
	fprintf(fout,"      IMPLICIT DOUBLE PRECISION (A-H,O-Z)\n");
	fprintf(fout,"      COMMON/LOGG/L(1)\n      LOGICAL RECALC\n");
	fprintf(fout,"      DIMENSION  AMEM(%d)\n",ListLength(l_var));
	fprintf(fout,"      COMMON/VARS/A(%d)\n",ListLength(l_var)+ListLength(l_fun));
	fprintf(fout,"      SAVE\n");
	fprintf(fout,"      DATA RECALC/.TRUE./,P1MEM/0.D0/\n");
	fprintf(fout,"      DO 1 I=1,%d\n",ListLength(l_var));
	fprintf(fout,"         IF (A(I).NE.AMEM(I)) THEN\n");
	fprintf(fout,"            RECALC=.TRUE.\n");
	fprintf(fout,"            AMEM(I)=A(I)\n");
	fprintf(fout,"         ENDIF\n1     CONTINUE\n");
	fprintf(fout,"      IF (RECALC) THEN\n");
	fprintf(fout,"         DO 2 I=1,1\n");
	fprintf(fout,"2        L(I)=0\n");
	
	for(i=1;i<=ListLength(l_fun);i++)
	{
		Term t;
		List l;

		fprintf(fout,"         A(%d)=",i+ListLength(l_var));
		t=ListNth(l_fun,i);
		for(l=params;l;l=ListTail(l))
			if(CompoundName(ListFirst(l))==t)
			{
				t=CompoundArg1(ListFirst(l));
				break;
			}
		f_wrt_term(fout,t,l_var,l_fun);
		fprintf(fout,"\n");
	}
	
	fprintf(fout,"      RECALC=.FALSE.\n      ENDIF\n");
	fprintf(fout,"      RETURN\n      END\n\n");
	
	fprintf(fout,"      SUBROUTINE VINI\n");
	fprintf(fout,"      IMPLICIT DOUBLE PRECISION (A-H,O-Z)\n");
	fprintf(fout,"      DOUBLE PRECISION SQRTS\n");
	fprintf(fout,"      COMMON/VARS/A(%d)\n",
			ListLength(l_var)+ListLength(l_fun));
	fprintf(fout,"      COMMON/SQS/SQRTS\n");
	fprintf(fout,"      COMMON/LOGG/L(1)\n");
	fprintf(fout,"      LOGICAL GWIDTH,RWIDTH\n");
	fprintf(fout,"      COMMON/WRTH/ GWIDTH,RWIDTH\n");
	fprintf(fout,"      SAVE\n      GWIDTH=.FALSE.\n");
	fprintf(fout,"      RWIDTH=.FALSE.\n      SQRTS= 1.0000D+03\n");
	for(i=1;i<=ListLength(l_var);i++)
	{
		Term p;
		List l;
		p=ListNth(l_var,i);
		for(l=params;l;l=ListTail(l))
			if(CompoundName(ListFirst(l))==p)
			{
				p=CompoundArg1(ListFirst(l));
				break;
			}
		fprintf(fout,"      A(%d)=",i);
		if(p==0)
			fprintf(fout,"0.0\n");
		if(is_integer(p))
			fprintf(fout,"%d.\n",(int)IntegerValue(p));
		if(is_float(p))
			fprintf(fout,"%g\n",FloatValue(p));
	}
	fprintf(fout,"      CALL INIT\n      RETURN\n      END\n\n");
	
	fprintf(fout,"      SUBROUTINE CPTH(PATH,D_SLASH,F_SLASH)\n");
	fprintf(fout,"      CHARACTER*60 PATH\n");
	fprintf(fout,"      CHARACTER*1 D_SLASH,F_SLASH\n");
	fprintf(fout,"      PATH='/users/semenov/comphep_33.15'\n");
	fprintf(fout,"      D_SLASH='/'\n      F_SLASH='/'\n");
	fprintf(fout,"      RETURN\n      END\n\n");	
			
	fclose(fout);
	
	for(l=diags_info;l;l=ListTail(l))
	{
		List l1;
		for(l1=CompoundArgN(ListFirst(l),3);l1;l1=ListTail(l1))
			l_cnv=add_new_cnv(l_cnv,ListFirst(l1));
	}
	
	l_cnv=SortedList(l_cnv,cnv_cmp);
	if(db[7])
	{
		printf("Conv:");DumpList(l_cnv);
		printf("Eps: ");DumpList(all_eps_l);
	}
	
	fout=fopen("sqme.f","w");
	if(fout==NULL)
	{
		perror("Writing sqme.f: ");
		return 0;
	}
	
	
	fprintf(fout,"************************************\n");
	fprintf(fout,"********* AmpLoop v. 2.0.0 *********\n");
	fprintf(fout,"************************************\n\n");
	fprintf(fout,"      FUNCTION SQME(NSUB,P)\n");
	fprintf(fout,"      IMPLICIT DOUBLE PRECISION (A-H,O-Z)\n");
	fprintf(fout,"      DIMENSION P(0:3,%d)\n",in_prt+out_prt);
	fprintf(fout,"      COMMON/VARS/A(%d)\n",
			ListLength(l_var)+ListLength(l_fun));
	fprintf(fout,"      COMMON/SCLR/PP(%d),EPS(%d)\n",
			ListLength(l_cnv)+1,ListLength(all_eps_l)+1);
	fprintf(fout,"      DOUBLE COMPLEX PP, EPS, AMP\n");
	for(l=ferm_a_v_d;l;l=ListTail(l))
	{
		List l1;
		l1=ListFirst(l);
		if(ListFirst(l1)==NewInteger(1) && ListNth(l1,4))
			fprintf(fout,"      DOUBLE PRECISION %s(0:3)\n",
					AtomValue(ListNth(l1,3)));
		if(ListFirst(l1)==NewInteger(2))
			fprintf(fout,"      DOUBLE PRECISION %s(0:3), %s(0:3)\n",
					AtomValue(ListNth(l1,2)),AtomValue(ListNth(l1,3)));
	}
	for(i=1;i<=in_prt+out_prt;i++)
		if(prtspin[i]==2)
			fprintf(fout,"      DOUBLE COMPLEX E%d(0:3)\n",i);
	
	fprintf(fout,"      DOUBLE PRECISION SQME\n      SAVE\n\n");
	
	for(l=ferm_a_v_d;l;l=ListTail(l))
		if(ListFirst(ListFirst(l))==NewInteger(1)&&ListNth(ListFirst(l),4))
	{
		int no;
		no=AtomValue(ListNth(ListFirst(l),2))[1]-'0';
		fprintf(fout,"      PMM=DSQRT(P(1,%d)**2+P(2,%d)**2+P(3,%d)**2)\n",
				no,no,no);
		fprintf(fout,"      E%d(0)=PMM/A(%d)\n",no,
				par_no(ListNth(ListFirst(l),4),l_var,l_fun));
		fprintf(fout,"      E%d(1)=P(1,%d)*P(0,%d)/PMM/A(%d)\n",
				no,no,no,par_no(ListNth(ListFirst(l),4),l_var,l_fun));
		fprintf(fout,"      E%d(2)=P(2,%d)*P(0,%d)/PMM/A(%d)\n",
				no,no,no,par_no(ListNth(ListFirst(l),4),l_var,l_fun));
		fprintf(fout,"      E%d(3)=P(3,%d)*P(0,%d)/PMM/A(%d)\n\n",
				no,no,no,par_no(ListNth(ListFirst(l),4),l_var,l_fun));
	}
	for(l=ferm_a_v_d;l;l=ListTail(l))
		if(ListFirst(ListFirst(l))==NewInteger(2))
	{
		int no;
		no=AtomValue(ListNth(ListFirst(l),2))[1]-'0';
		fprintf(fout,"      P%d(0)=1\n",no);
		fprintf(fout,"      P%d(1)=0\n",no);
		fprintf(fout,"      P%d(2)=0\n",no);
		fprintf(fout,"      P%d(3)=1\n",no);
		fprintf(fout,"      E%d(0)=0\n",no);
		fprintf(fout,"      E%d(1)=1\n",no);
		fprintf(fout,"      E%d(2)=0\n",no);
		fprintf(fout,"      E%d(3)=0\n\n",no);
	}
		
	for(i=1;i<=in_prt+out_prt;i++)
		if(prtspin[i]==2)
		{
			char cbuf[8];
			Atom p;
			sprintf(cbuf,"s%d",i);
			p=NewAtom(cbuf,0);
			fprintf(fout,"      CALL CLCEV(%d,E%d,A(%d))\n",
					i,i,par_no(p,l_var,l_fun));
		}
		
	
	for(i=1;i<=ListLength(l_cnv);i++)
	{
		int p1,p2;
		char c1,c2;
		char b1[8],b2[8];
		char e1[8],e2[8];
		
		p1=AtomValue(CompoundArg1(CompoundArg1(ListNth(l_cnv,i))))[1]-'0';
		p2=AtomValue(CompoundArg2(CompoundArg1(ListNth(l_cnv,i))))[1]-'0';
		c1=toupper(AtomValue(CompoundArg1(CompoundArg1(
				ListNth(l_cnv,i))))[0]);
		c2=toupper(AtomValue(CompoundArg2(CompoundArg1(
				ListNth(l_cnv,i))))[0]);
		
		if(c1=='P' && p1<=in_prt+out_prt)
			sprintf(b1,"P"),sprintf(e1,",%d)",p1);
		else
			sprintf(b1,"%c%d",c1,p1),sprintf(e1,")");
		
		if(c2=='P' && p2<=in_prt+out_prt)
			sprintf(b2,"P"),sprintf(e2,",%d)",p1);
		else
			sprintf(b2,"%c%d",c2,p2),sprintf(e2,")");
		
		fprintf(fout,"      PP(%d)=",i);
		fprintf(fout, "%s(0%s*%s(0%s-%s(1%s*%s(1%s",b1,e1,b2,e2,b1,e1,b2,e2);
		fprintf(fout,"-%s(2%s*%s(2%s-%s(3%s*%s(3%s\n",b1,e1,b2,e2,b1,e1,b2,e2);
	}
	
	i=0;
	for(l=all_eps_l;l;l=ListTail(l))
	{
		int p1,p2,p3,p4;
		char c1,c2,c3,c4;
		char b1[8],b2[8],b3[8],b4[8];
		char e1[8],e2[8],e3[8],e4[8];	
		
		int i1,i2,i3,i4;
		
		p1=AtomValue(ListNth(CompoundArg1(ListFirst(l)),1))[1]-'0';
		c1=toupper(AtomValue(ListNth(CompoundArg1(ListFirst(l)),1))[0]);
		p2=AtomValue(ListNth(CompoundArg1(ListFirst(l)),2))[1]-'0';
		c2=toupper(AtomValue(ListNth(CompoundArg1(ListFirst(l)),2))[0]);
		p3=AtomValue(ListNth(CompoundArg1(ListFirst(l)),3))[1]-'0';
		c3=toupper(AtomValue(ListNth(CompoundArg1(ListFirst(l)),3))[0]);
		p4=AtomValue(ListNth(CompoundArg1(ListFirst(l)),4))[1]-'0';
		c4=toupper(AtomValue(ListNth(CompoundArg1(ListFirst(l)),4))[0]);
	
		if(c1=='P' && p1<=in_prt+out_prt)
			sprintf(b1,"P"),sprintf(e1,",%d)",p1);
		else
			sprintf(b1,"%c%d",c1,p1),sprintf(e1,")");
		
		if(c2=='P' && p2<=in_prt+out_prt)
			sprintf(b2,"P"),sprintf(e2,",%d)",p2);
		else
			sprintf(b2,"%c%d",c2,p2),sprintf(e2,")");
		
		if(c3=='P' && p3<=in_prt+out_prt)
			sprintf(b3,"P"),sprintf(e3,",%d)",p3);
		else
			sprintf(b3,"%c%d",c3,p3),sprintf(e3,")");
		
		if(c4=='P' && p4<=in_prt+out_prt)
			sprintf(b4,"P"),sprintf(e4,",%d)",p4);
		else
			sprintf(b4,"%c%d",c4,p4),sprintf(e4,")");
		
		fprintf(fout,"      EPS(%3d)=\n",++i);
		
		for(i1=1;i1<=4;i1++)
		for(i2=1;i2<=4;i2++)
		for(i3=1;i3<=4;i3++)
		for(i4=1;i4<=4;i4++)
		{
			int sp[4];
			int sg=1;
			int j,k;
			sp[0]=i1;sp[1]=i2;sp[2]=i3;sp[3]=i4;
			for(j=0;j<4;j++)
				for(k=0;k<3;k++)
					if(sp[k]>sp[k+1])
					{
						int tmp;
						tmp=sp[k];
						sp[k]=sp[k+1];
						sp[k+1]=tmp;
						sg=-sg;
					}
			if(sp[0]==sp[1]||sp[1]==sp[2]||sp[2]==sp[3])
				continue;

		fprintf(fout,"     >          %c%s(%d%s*%s(%d%s*%s(%d%s*%s(%d%s\n",
				sg>0?'+':'-',b1, i1 ,e1,b2, i2 ,e2,b3, i3 ,e3,b4, i4 ,e4);
		}
		
	}
		
		
	fprintf(fout,"\n      AMP=0\n\n");
	
	for(l=diags_info;l;l=ListTail(l))
		fprintf(fout,"      CALL F%05d(AMP)\n",
				(int)IntegerValue(CompoundArg1(ListFirst(l))));
	
	fprintf(fout,"\n      SQME=AMP*CONJG(AMP)\n      RETURN\n      END\n\n");
	
	fclose(fout);
	
	for(l=diags_info;l;l=ListTail(l))
	{
		FILE *fin;
		char cbuf[16],bbuf[80];
		List l1;
		sprintf(cbuf,"f%05d.f",
				(int)IntegerValue(CompoundArg1(ListFirst(l))));
		fout=fopen(cbuf,"w");
		if(fout==NULL)
		{
			printf("Can not open file %s for writing\n",cbuf);
			return 0;
		}
		sprintf(cbuf,"f%05d.ff",
				(int)IntegerValue(CompoundArg1(ListFirst(l))));
		fin=fopen(cbuf,"r");
		if(fin==NULL)
		{
			printf("Can not open file %s\n",cbuf);
			return 0;
		}
		fprintf(fout,"************************************\n");
		fprintf(fout,"********* AmpLoop v. 2.0.0 *********\n");
		fprintf(fout,"************************************\n\n");
		fprintf(fout,"      SUBROUTINE F%05d(AMP)\n",
				(int)IntegerValue(CompoundArg1(ListFirst(l))));
		fprintf(fout,"      IMPLICIT DOUBLE PRECISION (A-H,O-Z)\n");
		
		
		if(CompoundArg2(ListFirst(l)))
		{
			fprintf(fout,
					"\n      COMMON/VARS/A(%d)\n      DOUBLE PRECISION ",
					ListLength(l_var)+ListLength(l_fun));
			i=0;
			for(l1=CompoundArg2(ListFirst(l));l1;l1=ListTail(l1))
			{
				i++;
				fprintf(fout,"%s",AtomValue(ListFirst(l1)));
				if(ListTail(l1))
					fprintf(fout,",");
				else
					fprintf(fout,"\n");
				if((i%6)==0 && ListTail(l1))
					fprintf(fout,"\n     *   ");
			}
			fprintf(fout,"      EQUIVALENCE ");
			i=0;
			for(l1=CompoundArg2(ListFirst(l));l1;l1=ListTail(l1))
			{
				i++;
				fprintf(fout,"(%s,A(%d))",AtomValue(ListFirst(l1)),
						par_no(ListFirst(l1),l_var,l_fun));
				if(ListTail(l1))
					fprintf(fout,",");
				else
					fprintf(fout,"\n");
				if(ListTail(l1) && (i%3==0))
					fprintf(fout,"\n     *   ");
			}
			fprintf(fout,"\n");
		}
		
		if(CompoundArgN(ListFirst(l),3))
		{
			i=1;
			fprintf(fout,"\n      COMMON/SCLR/PP(%d),EPS(%d)\n",
					ListLength(l_cnv)+1,ListLength(all_eps_l)+1);
			fprintf(fout,"      DOUBLE COMPLEX PP,EPS,");
			for(l1=CompoundArgN(ListFirst(l),3);l1;l1=ListTail(l1))
			{
				i++;
				fprintf(fout,"%s",AtomValue(CompoundArg2(ListFirst(l1))));
				if(ListTail(l1))
					fprintf(fout,",");
				else
					fprintf(fout,"\n");
				if((i%5)==0 && ListTail(l1))
					fprintf(fout,"\n     *   ");
			}
			fprintf(fout,"      EQUIVALENCE ");
			i=0;
			for(l1=CompoundArgN(ListFirst(l),3);l1;l1=ListTail(l1))
			{
				int cno;
				List l2;
				cno=0;
				for(l2=l_cnv;l2;l2=ListTail(l2))
				{
					cno++;
					if(CompoundArg2(ListFirst(l1))==
							CompoundArg2(ListFirst(l2)))
						break;
				}
				i++;
				fprintf(fout,"(%s,PP(%d))",
						AtomValue(CompoundArg2(ListFirst(l1))),cno);
				if(ListTail(l1))
					fprintf(fout,",");
				else
					fprintf(fout,"\n");
				if((i%3)==0 && ListTail(l1))
					fprintf(fout,"\n     *   ");
			}
			fprintf(fout,"\n");
		}
		
		fprintf(fout,"      DOUBLE COMPLEX  AMP, AMP1, PR\n");
		fprintf(fout,"      DOUBLE PRECISION LooFact, NumFact\n");
		fprintf(fout,"      SAVE\n\n");
		
		while(fgets(bbuf,80,fin)!=NULL)
			fputs(bbuf,fout);
		fclose(fin);
		fclose(fout);
		unlink(cbuf);
	}
	
	return 1;
}

static List ait_l;
	
static void set_atom(Atom a)
	{
	List li;
	li=ait_l;
	while(!is_empty_list(li))
		{
		if(ListFirst(li)==a)
			return;
		li=ListTail(li);
		}
	ait_l=AppendFirst(ait_l,a);
	return;
	}
	
static void atoms_in_term(Term t)
	{
	if(is_atom(t))
		{
		set_atom(t);
		return;
		}
	if(is_compound(t))
		{
		int i,ac;
		ac=CompoundArity(t);
		for(i=1;i<=ac;i++)
			atoms_in_term(CompoundArgN(t,i));
		return;
		}
	if(is_list(t))
		{
		while(!is_empty_list(t))
			{
			atoms_in_term(ListFirst(t));
			t=ListTail(t);
			}
		return;
		}
	return;
	}
	
static List AtomsInTerm(Term t)
	{
	ait_l=NewList();
	atoms_in_term(t);
	return ait_l;
	}


static void add_all_p(List *lp, Atom p)
{
	List l1;
	
	if(ListMember(*lp,p)) return;
	
	for(l1=params;l1;l1=ListTail(l1))
		if(CompoundName(ListFirst(l1))==p)
			break;
	if(!l1)
	{
		printf("Wrong model (can not find parameter ");
		WriteTerm(p);puts(")");
		exit(0);
	}
	if(!is_compound(CompoundArg1(ListFirst(l1))))
	{
		*lp=AppendLast(*lp,p);
		return;
	}
	else
	{
		List l2,l3;
		*lp=AppendLast(*lp,p);
		l2=AtomsInTerm(CompoundArg1(ListFirst(l1)));
		for(l3=l2;l3;l3=ListTail(l3))
			add_all_p(lp,ListFirst(l3));
		FreeAtomic(l2);
		return;
	}
}

static void collect_prm(List *lv, List *lf)
{
	List l1, l2, l3;
	int i;
	l1=NewList();
		
	for(l2=diags_info;l2;l2=ListTail(l2))
		for(l3=CompoundArg2(ListFirst(l2));l3;l3=ListTail(l3))
			if(!ListMember(l1,ListFirst(l3)))
				l1=AppendLast(l1,ListFirst(l3));
	for(i=1;i<=in_prt+out_prt;i++)
		if(pmass[i] && !ListMember(l1,pmass[i]))
			l1=AppendLast(l1,pmass[i]);
	
	l2=NewList();

	for(i=1;i<=in_prt+out_prt;i++)
	if(prtspin[i]==2)
	{
		char cbuf[8];
		Atom p;
		sprintf(cbuf,"s%d",i);
		p=NewAtom(cbuf,0);
		for(l2=params;l2;l2=ListTail(l2))
			if(CompoundName(ListFirst(l2))==p)
				break;
		if(!l2)
			params=AppendFirst(params,MakeCompound2(p,NewFloat(-1),0));
		if(!ListMember(l1,p))
			l1=AppendLast(l1,p);
	}
	
	l2=NewList();
	
	for(l3=l1;l3;l3=ListTail(l3))
		add_all_p(&l2,ListFirst(l3));
	FreeAtomic(l1);
	
	for(l1=params;l1;l1=ListTail(l1))
		if(ListMember(l2,CompoundName(ListFirst(l1))))
		{
			if(!is_compound(CompoundArg1(ListFirst(l1))))
				*lv=AppendFirst(*lv,CompoundName(ListFirst(l1)));
			else
				*lf=AppendFirst(*lf,CompoundName(ListFirst(l1)));
		}
	FreeAtomic(l2);
}

static int arg_prior(Term tt)
	{
	Functor fu;
	int arity, prior;
	Atom name, assoc;
	
	if(AtomicType(tt)!='c')
		return 0;
		
	fu=CompoundFunctor(tt);
	arity=FunctorArity(fu);
	if(arity>2) return 0;
	name=FunctorName(fu);
	if(arity==2)
		{
		if(GetOperator(name,OP_INFIX,&assoc,&prior)==0)
			return 0;
		else
			return prior;
		}
	if(GetOperator(name,OP_PREFIX,&assoc,&prior)!=0)
		return prior;
	if(GetOperator(name,OP_POSTFIX,&assoc,&prior)!=0)
		return prior;
	return 0;
	}
	


static int pri_begin(Atom a)
	{
	char *s;
	if(WideWriting) return 1;
	s=AtomValue(a);
	return  isalpha(s[0]) || isdigit(s[0]) ;
	}
	
static int pri_end(Atom a)
	{
	char *s;
	int len;
	if(WideWriting) return 1;
	s=AtomValue(a);
	len=strlen(s);
	return  isalpha(s[len-1]) || isdigit(s[len-1]) ;
	}
	


static int f_wrt_term(FILE *file, Term T, List l_v, List l_f)
	{
	char c;
	int arg,arity,i;
	int AlwaysBracets=0;
	Functor fu;
	c=AtomicType(T);
	switch(c)
		{
		case 'i':
			return fprintf(file,"%ld",IntegerValue(T));
		case 'a':
				return fprintf(file,"A(%d)",par_no(T,l_v,l_f));
		case 'f':
			return fprintf(file,"%g",FloatValue(T));
		case 'e':
			return fprintf(file,"?");
		case '?':
			return fprintf(file,"?");
		case 'L':
		case 'l':
			return fprintf(file,"?");
		case 'c':
			{
			Atom oper;
			int retval=0;
			fu=CompoundFunctor(T);
			arity=FunctorArity(fu);
			oper=FunctorName(fu);
			if(oper==A_FBRACET)
				{
				retval=fprintf(file,"{");
				for(i=1;i<=arity;i++)
					{
					retval+=f_wrt_term(file,
						CompoundArgN(T,i),l_v,l_f);
					if(i!=arity)
						retval+=fprintf(file,", ");
					}
				retval+=fprintf(file,"}");
				return retval;
				}
			if(arity==1)
				{
				Atom assoc;
				int prior, prior1;
				if(oper==A_SQRT)
					{
					retval=fprintf(file,"DSQRT(");
					retval+=f_wrt_term(file,
					CompoundArg1(T),l_v,l_f);
					retval+=fprintf(file,")");
					return retval;
					}
				if(GetOperator(oper,OP_PREFIX,&assoc,&prior)!=0)
					{
					prior1=arg_prior(CompoundArg1(T));
					if(assoc==OP_FX) prior1++;
					retval=fprintf(file,"%s",AtomValue(oper));
					if(pri_end(oper)) retval+=fprintf(file," ");
					if(prior1>prior || (AlwaysBracets && prior1>1))
						retval+=fprintf(file,"(");
					retval+=f_wrt_term(file,CompoundArg1(T)
					,l_v,l_f);
					if(prior1>prior || (AlwaysBracets && prior1>1))
						retval+=fprintf(file,")");
					return retval;
					}
				if(GetOperator(oper,OP_POSTFIX,&assoc,&prior)!=0)
					{
					prior1=arg_prior(CompoundArg1(T));
					if(assoc==OP_XF) prior1++;
					if(prior1>prior || (AlwaysBracets && prior1>1))
						retval+=fprintf(file,"(");
					retval+=f_wrt_term(file,CompoundArg1(T)
					,l_v,l_f);
					if(prior1>prior || (AlwaysBracets && prior1>1))
						retval+=fprintf(file,")");
					if(pri_begin(oper)) retval+=fprintf(file," ");
					retval+=fprintf(file,"%s",AtomValue(oper));
					return retval;
					}
				}
			if(arity==2)
				{
				Atom assoc;
				int prior, prior1, prior2;
				if(GetOperator(oper,OP_INFIX,&assoc,&prior)!=0)
					{
					prior1=arg_prior(CompoundArg1(T));
					prior2=arg_prior(CompoundArg2(T));
					if(assoc==OP_XFX || assoc==OP_XFY) prior1++;
					if(assoc==OP_XFX || assoc==OP_YFX) prior2++;
					if(prior1>prior || (AlwaysBracets && prior1>1))
						retval+=fprintf(file,"(");
					retval+=f_wrt_term(file,CompoundArg1(T)
					,l_v,l_f);
					if(prior1>prior || (AlwaysBracets && prior1>1))
						retval+=fprintf(file,")");
					if(pri_begin(oper)) retval+=fprintf(file," ");
					retval+=fprintf(file,"%s",AtomValue(oper));
					if(pri_end(oper)) retval+=fprintf(file," ");
					if(prior2>prior || (AlwaysBracets && prior2>1))
						retval+=fprintf(file,"(");
					retval+=f_wrt_term(file,CompoundArg2(T),
					l_v,l_f);
					if(prior2>prior || (AlwaysBracets && prior2>1))
						retval+=fprintf(file,")");
					return retval;
					}
				}
			retval+=fprintf(file,"%s(",AtomValue(FunctorName(fu)));
			for(arg=1;arg<=arity;arg++)
				{
				if(arg!=1)
					retval+=fprintf(file,", ");
				retval+=f_wrt_term(file,CompoundArgN(T,arg),
				l_v,l_f);
				}
			retval+=fprintf(file,")");
			return retval;
			}
			
		}
	return 0;
	}
	

