#include <stdio.h>
#include <string.h>
#include "terms.h"
#include "ga.h"

int Verbose = 1;

int in_prt=0, out_prt=0, loop_no=-1, diag_no=0, sub_no=0;
Atom proc_name=0, subproc_name=0;

int ro[10]={1,1,1,1,1,1,1,1,1,1};
int db[10]={0,0,0,0,0,0,0,0,0,0};
extern int exclude_PN;


void main(int ac, char *av[])
	{
	Term d;
	int i;
	FILE *fout;
	char *fname=NULL;
	if(ac<3)
		{
		puts("More arguments required");
		return;
		}

	InitAtoms();
	
	
	if(itrSetIn(av[1])==0)
		{
		printf("Can not open vertices file %s\n",av[1]);
		return;
		}
		
	if(readd()==0)
		return;
		
	for(i=3;i<ac;i++)
	{
		if(strcmp(av[i],"-o")==0)
		{
			fname=av[++i];
			continue;
		}
		if(strcmp(av[i],"-avp")==0)
		{
			ave_l=AppendLast(ave_l,NewAtom(av[++i],0));
			continue;
		}
		if(strcmp(av[i],"-hsz")==0)
		{
			if(sscanf(av[++i],"%d",&HASH_SZ)!=1)
			{
				puts("Wrong hash size");
				return;
			}
			continue;
		}
		if(strcmp(av[i],"-epn")==0)
		{
			exclude_PN=1;
			continue;
		}
		if(strncmp(av[i],"-ro",3)==0)
		{
			int j;
			for(j=0;j<10;ro[j++]=0);
			j=3;
			while(av[i][j])
				ro[av[i][j++]-'0']=1;
			continue;
		}
		if(strncmp(av[i],"-db",3)==0)
		{
			int j;
			for(j=0;j<10;db[j++]=0);
			j=3;
			if(av[i][j])
				db[0]=1;
			while(av[i][j])
				db[av[i][j++]-'0']=1;
			continue;
		}
		printf("Unknown option %s\n",av[i]);
	}
	
				
	if(fname!=NULL)
		fout=fopen(fname,"w");
	else
		fout=stdout;
	
	SetInputFile(av[2]);
	while((d=read_vrt()))
		{
		if(!gen_mom(d))
			return;
		if(!find_vrt(d))
			return;
		if(!proc_color(d))
			return;
		if(color_factor==0)
		{
			FreeAtomic(d);
			continue;
		}
		if(1)
			{
			fWriteTerm(stderr,CompoundArg1(d));
			fprintf(stderr,"          \r");
			fflush(stderr);
			}
		if(!out_diagr(d,fout))
			return;
		
		if(ro[3]==0)
		{
			if(!build_diag(d))
				return;
			if(!fort_out_d())
				return;
		}
		
		FreeAtomic(color_str);
		FreeAtomic(td_num);
		FreeAtomic(td_prop);
		FreeAtomic(flines);
		FreeAtomic(floops);
		FreeAtomic(d);
		}
	if(db[7])
	{
		printf("Diagrams summary:\n");
		DumpList(diags_info);
	}
	if(!ro[3])
	{
		fort_out_a();
		FreeAtomic(diags_info);
	}
	if(ro[0])
		fprintf(fout,"end$\n");
	fprintf(stderr, "                                                 \n");	
	CloseInputFile();
	AtomStatistics();
	ListStatistics();
	}
	
List CommaToList(Term t)
	{
	List li;
	li=NewList();
	while(is_compound(t) && CompoundName(t)==OPR_COMMA)
		{
		Term t1;
		li=AppendLast(li,ConsumeCompoundArg(t,1));
		t1=ConsumeCompoundArg(t,2);
		FreeAtomic(t);
		t=t1;
		}
	li=AppendLast(li,t);
	return li;
	}

void ErrorInfo(int errno)
	{
	if(!IsTermInput())
			printf("File \"%s\", line %d: ",CurrentInputFile(),
				CurrentInputLine());
	printf("Error %03d: ",errno);
	}	

void ReplAtom(Term t, Atom from, Atom to)
	{
	if(is_compound(t))
		{
		int i, ar;
		ar=CompoundArity(t);
		for(i=1;i<=ar;i++)
			{
			if(CompoundArgN(t,i)==from)
				SetCompoundArg(t,i,to);
			else
				ReplAtom(CompoundArgN(t,i),from,to);
			}
		return;
		}
	if(is_list(t))
		{
		while(!is_empty_list(t))
			{
			if(ListFirst(t)==from)
				ChangeList(t,to);
			else
				ReplAtom(ListFirst(t),from,to);
			t=ListTail(t);
			}
		}
	return;
	}
	
int gcf(int i1, int i2)
	{
	if(i1==0 || i2==0)
		return 1;
	if(i1<0)
		i1=-i1;
	if(i2<0)
		i2=-i2;
	while(i1!=i2)
		if(i1>i2)
			i1-=i2;
		else
			i2-=i1;
	return i1;
	}

void WriteVertex(List pl)
	{
	printf("(");
	while(!is_empty_list(pl))
		{
		printf("%s",AtomValue(CompoundArg1(ListFirst(pl))));
		pl=ListTail(pl);
		if(pl)
			printf(", ");
		}
	printf(")");
	}


void WriteBlank(FILE *f, int space)
	{
	int i;
	for(i=0;i<space;i++)
		fprintf(f," ");
	}
