#include <stdio.h>
#include <ctype.h>
#include "terms.h"
#include "ga.h"

List diags = 0;
Term out_sym_fact, loop_sym_fact;
Atom prtnm[8];
	
Term read_vrt(void)
	{
	Term rt,rt1,dnm;
	List vl;
	char *cname;
	int curv=1;
	int curout=1;
	int curin=1;
	vl=NewList();
	
	do	{
		rt=ReadTerm();
		if(rt==0)
			return 0;
			
		if(!is_compound(rt))
			{
			printf("Error in line %d\n",CurrentInputLine()-1);
			return 0;
			}
		cname=AtomValue(CompoundName(rt));
		if(strcmp(cname,"Process")==0)
			{
			int lno;
			lno=IntegerValue(CompoundArg2(CompoundArg2(rt)));
			if(loop_no==-1)
				loop_no=lno;
			else
				if(lno!=loop_no)
					{
					printf("Error in line %d : diagr with diff loop no\n",CurrentInputLine()-1);
					}
			subproc_name=CompoundArg2(CompoundArg1(rt));
			}
		if(strcmp(cname,"numberinout")==0)
			{
			in_prt=IntegerValue(CompoundArg2(CompoundArg1(rt)));
			out_prt=IntegerValue(CompoundArg2(CompoundArg2(rt)));
			}
			
		if(strcmp(cname,"Subprocess")==0)
		{
			sub_no=IntegerValue(CompoundArg2(CompoundArg1(rt)));
			subproc_name=CompoundArg2(CompoundArg2(rt));
		}
		
		} while(strcmp(cname,"Diagr"));
	
	dnm=rt;
	
	diag_no=IntegerValue(CompoundArg2(CompoundArg1(dnm)));
	
	rt=ReadTerm();
	rt1=CompoundArg2(rt);
	if(!is_integer(rt1) &&
			(!is_compound(rt1) || CompoundName(rt1)!=OPR_DIV))
		{
		fprintf(stderr,"Error in line %d.\n",CurrentInputLine());
		exit(0);
		}	
	out_sym_fact=rt1;
	if(loop_no>0)
	{
		rt=ReadTerm();
		rt1=CompoundArg2(rt);
		if(!is_integer(rt1) &&
			(!is_compound(rt1) || CompoundName(rt1)!=OPR_DIV))
		{
			fprintf(stderr,"Error in line %d.\n",CurrentInputLine());
			exit(0);
	    }
		loop_sym_fact=rt1;
	}
	else
		loop_sym_fact=NewInteger(1);
	
	
	while((rt=ReadTerm()))
		{
		int i;
		char *cname;
		if(!is_compound(rt) && !is_atom(rt))
			{
			printf("Error in line %d\n",CurrentInputLine()-1);
			return 0;
			}
		if(is_atom(rt))
			break;
		cname=AtomValue(CompoundName(rt));
		
		if(cname[0]=='V' && isdigit(cname[1]))
			{
			int no;
			List pl,ll;
			sscanf(cname+1,"%d",&no);
			if(no!=curv)
				{
				printf("Error in line %d (vertex numbering)\n",
						CurrentInputLine()-1);
				printf("Expected %d, got %d.\n",curv,no);
				abort();
				}
			no=CompoundArity(rt);
			pl=ll=NewList();
			for(i=1;i<=no;i++)
				{
				Term pt;
				Atom tto;
				char *tton;
				int ttoi;
				pt=ConsumeCompoundArg(rt,i);
				if(!is_compound(pt))
					{
					printf("Error in line %d (particle)\n",
						CurrentInputLine()-1);
					return 0;
					}
				pl=AppendLast(pl,CompoundName(pt));
				tto=CompoundArg1(pt);
				if(!is_atom(tto))
					{
					printf("Error in line %d (line)\n",
						CurrentInputLine()-1);
					return 0;
					}	
				tton=AtomValue(tto);
				ttoi=0;
				if(tton[0]=='o')
					{
					sscanf(tton+1,"%d",&ttoi);
					prtnm[ttoi]=CompoundName(pt);
					ttoi+=200-in_prt;
					curout++;
					}
				else
					if(tton[0]=='v')
						sscanf(tton+1,"%d",&ttoi);
					else
						if(tton[0]=='i')
							{ 
							sscanf(tton+1,"%d",&ttoi);
							prtnm[ttoi]=CompoundName(pt);
							ttoi+=100;
							curin++;
							}
						else
							{
							printf("Error in line %d (ltype)\n",
								CurrentInputLine()-1);
							return 0;
							}
				ll=AppendLast(ll,NewInteger(ttoi));
				}
			FreeAtomic(rt);	
			rt=MakeCompound(A_I,8);
			SetCompoundArg(rt,1,pl);
			SetCompoundArg(rt,2,ll);
			vl=AppendLast(vl,rt);
			curv++;
			continue;
			}
				
		break;	
		
		}
	
	
	if(in_prt==0)
		{
		in_prt=curin-1;
		out_prt=curout-1;
		if(in_prt<1 || out_prt<1)
			{
			printf("Error in line %d (lpno); %d in, %d out.\n",
				CurrentInputLine()-1,in_prt,out_prt);
			return 0;
			}
		}
	else
		{
		if(in_prt!=curin-1 || out_prt!=curout-1)
			{
			printf("Error in line %d (dst iono)\n",CurrentInputLine()-1);
			return 0;
			}
		}
	
	return MakeCompound2(OPR_DIV,dnm,vl);
		
	}

