#include <stdio.h>
#include "terms.h"
#include "ga.h"


static List find_floop(List *fl)
	{
	List l1,l2;
	Integer n_v, n_p;
	l1=*fl;
	
	while(!is_empty_list(l1))
		{
		if(CompoundArg2(ListFirst(l1))==NewInteger(-1) && 
		   is_compound(CompoundArgN(ListFirst(l1),4)))
		   	break;
		l1=ListTail(l1);
		}
	if(is_empty_list(l1))
		return 0;
	
	n_v=CompoundArg1(CompoundArgN(ListFirst(l1),3));
	n_p=CompoundArg2(CompoundArgN(ListFirst(l1),3));
	
	l2=NewList();
		
	while(l1)
		{
		Atom pi,po;
		int vno;
		Integer nv,np;
		Term nxt;
		pi=CompoundArg1(ListFirst(l1));
		vno=IntegerValue(CompoundArg1(CompoundArgN(ListFirst(l1),3)));
		*fl=CutFromList(*fl,l1);
		l1=*fl;
		while(!is_empty_list(l1))
			{
			if(CompoundArg1(CompoundArgN(ListFirst(l1),3))==NewInteger(vno))
				break;
			l1=ListTail(l1);
			}
		if(is_empty_list(l1))
			{
			puts("\nError: invalid fermion loop");
			return 0;
			}
		po=CompoundArg1(ListFirst(l1));
		nxt=MakeCompound(A_I,4);
		SetCompoundArg(nxt,1,NewInteger(vno));
		SetCompoundArg(nxt,2,pi);
		SetCompoundArg(nxt,3,po);
		SetCompoundArg(nxt,4,ConsumeCompoundArg(ListFirst(l1),5));
		l2=AppendLast(l2,nxt);
		if(!is_compound(CompoundArgN(ListFirst(l1),4)))
			{
			puts("\nError: invalid fermion loop");
			return 0;
			}
		
		nv=CompoundArg1( CompoundArgN(ListFirst(l1),4) );
		np=CompoundArg2( CompoundArgN(ListFirst(l1),4) );
		
		if(nv == n_v && np == n_p )
			{
			*fl=CutFromList(*fl,l1);
			return l2;
			}
		
		*fl=CutFromList(*fl,l1);
		l1=*fl;
		while(!is_empty_list(l1))
			{
			Term t1;
			t1=CompoundArgN(ListFirst(l1),3);
			if(is_compound(t1) && CompoundArg1(t1)==nv &&
				CompoundArg2(t1)==np)
				break;
			l1=ListTail(l1);
			}
		if(is_empty_list(l1))
			{
			puts("\nError: invalid fermion loop");
			return 0;
			}
		}
		
	return 0;	
	
	}

static List find_fline(List *fl)
	{
	List l1,l2;
	Integer pin, pout;
	List momin, momout;
	Atom hiin, hiout;
	l1=*fl;
	
	while(!is_empty_list(l1))
		{
		if(CompoundArg2(ListFirst(l1))==NewInteger(-1) && 
		   is_integer(CompoundArgN(ListFirst(l1),4)))
		   	break;
		l1=ListTail(l1);
		}
	if(is_empty_list(l1))
		return 0;
	
	pin=CompoundArgN(ListFirst(l1),4);
	momin=ConsumeCompoundArg(ListFirst(l1),5);
	hiin=CompoundArgN(ListFirst(l1),6);
	
	l2=NewList();
		
	while(l1)
		{
		Atom pi,po;
		int vno;
		Integer nv,np;
		Term nxt;
		pi=CompoundArg1(ListFirst(l1));
		vno=IntegerValue(CompoundArg1(CompoundArgN(ListFirst(l1),3)));
		*fl=CutFromList(*fl,l1);
		l1=*fl;
		while(!is_empty_list(l1))
			{
			if(CompoundArg1(CompoundArgN(ListFirst(l1),3))==NewInteger(vno))
				break;
			l1=ListTail(l1);
			}
		if(is_empty_list(l1))
			{
			puts("\nError: invalid fermion line");
			return 0;
			}
		po=CompoundArg1(ListFirst(l1));
		nxt=MakeCompound(A_I,4);
		SetCompoundArg(nxt,1,NewInteger(vno));
		SetCompoundArg(nxt,2,pi);
		SetCompoundArg(nxt,3,po);
		SetCompoundArg(nxt,4,ConsumeCompoundArg(ListFirst(l1),5));
		l2=AppendLast(l2,nxt);
		if(is_integer(CompoundArgN(ListFirst(l1),4)))
			{
			pout=CompoundArgN(ListFirst(l1),4);
			momout=CopyTerm(CompoundArgN(nxt,4));
			hiout=CompoundArgN(ListFirst(l1),6);
			l2=AppendFirst(l2,MakeCompound2(OPR_DIV,pin,
				MakeCompound2(OPR_DIV,momin,hiin)));
			l2=AppendLast(l2,MakeCompound2(OPR_DIV,pout,
				MakeCompound2(OPR_DIV,momout,hiout)));
			*fl=CutFromList(*fl,l1);
			return l2;
			}
		nv=CompoundArg1( CompoundArgN(ListFirst(l1),4) );
		np=CompoundArg2( CompoundArgN(ListFirst(l1),4) );
		*fl=CutFromList(*fl,l1);
		l1=*fl;
		while(!is_empty_list(l1))
			{
			Term t1;
			t1=CompoundArgN(ListFirst(l1),3);
			if(is_compound(t1) && CompoundArg1(t1)==nv &&
				CompoundArg2(t1)==np)
				break;
			l1=ListTail(l1);
			}
		if(is_empty_list(l1))
			{
			puts("\nError: invalid fermion line");
			return 0;
			}
		}
		
	return 0;	
	
	}

List flines, floops;
	
int out_diagr(Term d, FILE *outf)
	{
	List l;
	List l1,l2,l3,l4,l5;
	int i,j;
	
	if(ro[0])
		fprintf(outf,"BeginDiagr(%d)$\n",
		(int)IntegerValue(CompoundArg2(CompoundArg1(CompoundArg1(d)))));

	
	l=CompoundArg2(d);
	i=0;
	if(ro[1])
	while(!is_empty_list(l))
		{
		int plen;
		i++;
		fprintf(outf,"%% Vertex %d\n",i);
	
		l1=CompoundArg1(ListFirst(l));
		l2=CompoundArg2(ListFirst(l));
		l3=CompoundArgN(ListFirst(l),3);
		l4=CompoundArgN(ListFirst(l),4);
		l5=CompoundArgN(ListFirst(l),7);
		while(!is_empty_list(l1))
			{
			Term t;
			fprintf(outf,"%%\t%5s  ",AtomValue(ListFirst(l1)));
			t=ListFirst(l2);
			if(is_compound(t))
				fprintf(outf," vrt %d   ",(int)IntegerValue(CompoundArg1(t)));
			else
				{
				j=IntegerValue(t);
				if(j<150)
					fprintf(outf," in  %d   ",j-100);
				else
					fprintf(outf," out %d   ",j-200);
				}
			t=ListFirst(l3);
			plen=ListLength(t)*3;
			while(!is_empty_list(t))
				{
				j=IntegerValue(ListFirst(t));
				if(j<0)
					{
					j=-j;
					fprintf(outf,"-");
					}
				else
					fprintf(outf,"+");
				if(j<=in_prt+out_prt)
					fprintf(outf,"p%d",j);
				else
					fprintf(outf,"q%d",j-in_prt-out_prt);
				t=ListTail(t);
				}
			WriteBlank(outf,20-plen);
			t=ListFirst(l4);
			if(!is_empty_list(t))
				{
				fprintf(outf," vi=");
				fWriteTerm(outf,t);
				}
				
			t=ListFirst(l5);	
			if(is_empty_list(t))
				fprintf(outf,"\n");
			else
				{
				fprintf(outf," hel=");
				fWriteTerm(outf,t);
				fprintf(outf,"\n");
				}
				
			l1=ListTail(l1);
			l2=ListTail(l2);
			l3=ListTail(l3);
			l4=ListTail(l4);
			l5=ListTail(l5);
			}
			
			{
			Term a2;
			a2=CompoundArgN(ListFirst(l),5);
			fprintf(outf,"%% Factor ");
			fWriteTerm(outf,CompoundArg2(a2));
			fprintf(outf," ");
			fWriteTerm(outf,CompoundArgN(a2,3));
			fprintf(outf,"\n");
			}
		
		l=ListTail(l);
		}	
	
		
	if(ro[2])
	{
		fprintf(outf,"%% Color structure ");
		fWriteTerm(outf,color_str);
		fprintf(outf,"\n");
	}
	
	l=CompoundArg2(d);
	i=0;
	l4=NewList();
	while(!is_empty_list(l))
		{
		List lh;
		i++;
		l1=CompoundArg1(ListFirst(l));
		l2=CompoundArg2(ListFirst(l));
		l3=CompoundArgN(ListFirst(l),3);
		lh=CompoundArgN(ListFirst(l),7);
		j=0;
		while(!is_empty_list(l1))
			{
			Term prt;
			j++;
			prt=GetAtomProperty(ListFirst(l1),PROP_TYPE);
			if(is_compound(prt) && CompoundName(prt)==OPR_PARTICLE &&
				CompoundArgN(prt,4)==NewInteger(1))
				{
				Term np;
				np=MakeCompound(A_I,6);
				SetCompoundArg(np,1,ListFirst(l1));
				if(ListFirst(l1)==CompoundArg1(prt))
					SetCompoundArg(np,2,NewInteger(1));
				else
					SetCompoundArg(np,2,NewInteger(-1));
				SetCompoundArg(np,3,MakeCompound2(OPR_DIV,NewInteger(i),NewInteger(j)));
				SetCompoundArg(np,4,CopyTerm(ListFirst(l2)));
				SetCompoundArg(np,5,CopyTerm(ListFirst(l3)));
				SetCompoundArg(np,6,ListFirst(lh));
				l4=AppendLast(l4,np);
				}
			l1=ListTail(l1);
			l2=ListTail(l2);
			l3=ListTail(l3);
			lh=ListTail(lh);
			}
		l=ListTail(l);
		}
	
		
/*	if(l4)
	{
	DumpList(CompoundArg2(d));puts("");
    DumpList(l4);
	}
*/
			
	flines=NewList();
	while((l1=find_fline(&l4))!=0)
		flines=AppendLast(flines,l1);

	floops=NewList();
	while((l1=find_floop(&l4))!=0)
		floops=AppendLast(floops,l1);

/*
	DumpList(flines);
	DumpList(floops);
	getchar();	
*/
	if(!is_empty_list(l4))
		return 0;
		
	if(!is_empty_list(flines) && ro[2])
		{
		fprintf(outf,"%% Fermion lines:\n");
		l1=flines;
		while(!is_empty_list(l1))
			{
			fprintf(outf,"%%     ");
			l2=ListFirst(l1);
			while(!is_empty_list(l2))
				{
				Term t1;
				t1=ListFirst(l2);
				if(CompoundArity(t1)==2)
					{
					int pno;
					pno=IntegerValue(CompoundArg1(t1));
					if(pno<150)
						fprintf(outf,"in%d",pno-100);
					else
						fprintf(outf,"out%d",pno-200);
					fprintf(outf,"(%s)",AtomValue(CompoundArg2(CompoundArg2(t1))));
					}
				else
					fprintf(outf,"%d",(int)IntegerValue(CompoundArg1(t1)));
				l2=ListTail(l2);
				if(!is_empty_list(l2))
					fprintf(outf," -> ");
				}
			fprintf(outf,"\n");
			l1=ListTail(l1);
			}
		}
		
	if(!is_empty_list(floops) && ro[2])
		{
		fprintf(outf,"%% Fermion loops:\n");
		l1=floops;
		while(!is_empty_list(l1))
			{
			fprintf(outf,"%%     -> ");
			l2=ListFirst(l1);
			while(!is_empty_list(l2))
				{
				Term t1;
				t1=ListFirst(l2);
				fprintf(outf,"%d",(int)IntegerValue(CompoundArg1(t1)));
				l2=ListTail(l2);
				fprintf(outf," -> ");
				}
			fprintf(outf,"\n");
			l1=ListTail(l1);
			}
		}
	
	if(ro[3])
	{
		fprintf(outf,"ColorFactor:=%d$\n",color_factor);
		wrt_c_f(d,outf);
		wrt_vrt(d,outf);
	}
	else
		ext_c_f(d);
	
	if(ro[3])
	{
	fprintf(outf,"FermLinesNo:=%d$\n",ListLength(flines));
	l1=flines;
	i=0;
	while(!is_empty_list(l1))
		{
		Term tt;
		i++;
		fprintf(outf,"FermLine(%d):=\tlist(",i);
		l2=ListFirst(l1);
		j=0;
		tt=ListFirst(l2);
		l2=ListTail(l2);
		j=IntegerValue(CompoundArg1(tt));
		fprintf(outf,"\tInFerm(%s,%d,",j>150?"out":"in",(j%100));
		write_moment(outf,CompoundArg1(CompoundArg2(tt)));
		fprintf(outf,",%s),\n\t\t",AtomValue(CompoundArg2(CompoundArg2(tt))));
		while(!is_empty_list(ListTail(l2)))
			{
			Term prp;
			tt=ListFirst(l2);
			prp=GetAtomProperty(CompoundArg2(tt),PROP_TYPE);
			if(CompoundName(prp)!=OPR_PARTICLE)
				{
				puts("Error: Unphysical particle");
				exit(0);
				}
			prp=CompoundArgN(prp,5);
			fprintf(outf,"Vrt%d,",(int)IntegerValue(CompoundArg1(tt)));
			if(CompoundArity(ListFirst(ListTail(l2)))!=2)
				{
				fprintf(outf,"(GA(");
				write_moment(outf,CompoundArgN(tt,4));
				fprintf(outf,")+%s),\n\t\t",prp?AtomValue(prp):"0");
				}
			l2=ListTail(l2);
			}
		tt=ListFirst(l2);
		j=IntegerValue(CompoundArg1(tt));
		fprintf(outf,"OutFerm(%s,%d,",j>150?"out":"in",(j%100));
		write_moment(outf,CompoundArg1(CompoundArg2(tt)));
		fprintf(outf,",%s) )$\n",AtomValue(CompoundArg2(CompoundArg2(tt))));
		l1=ListTail(l1);
		}
	
	
	fprintf(outf,"FermLoopsNo:=%d$\n",ListLength(floops));
	l1=floops;
	i=0;
	while(!is_empty_list(l1))
		{
		Term tt;
		i++;
		fprintf(outf,"FermLoop(%d):=\t",i);
		l2=ListFirst(l1);
		j=0;
		while(!is_empty_list(l2))
			{
			Term prp;
			tt=ListFirst(l2);
			prp=GetAtomProperty(CompoundArg2(tt),PROP_TYPE);
			if(CompoundName(prp)!=OPR_PARTICLE)
				{
				puts("Error: Unphysical particle");
				exit(0);
				}
			prp=CompoundArgN(prp,5);
			fprintf(outf,"Vrt%d*",(int)IntegerValue(CompoundArg1(tt)));
			fprintf(outf,"(GA(");
			write_moment(outf,CompoundArgN(tt,4));
			fprintf(outf,")+%s)",prp?AtomValue(prp):"0");
			l2=ListTail(l2);
			if(!is_empty_list(l2))
				fprintf(outf,"*\n\t\t");
			else
				fprintf(outf,"$\n");
			}
		l1=ListTail(l1);
		}
			
	}
	
	if(ro[0])
	end_diag(d,outf);
		
	return 1;
	}
