#include <stdio.h>
#include "terms.h"
#include "ga.h"

static void write_l_line(FILE *f, Term a2);
static List vi_as_ind;

static int in_loop(List l)
	{
	while(!is_empty_list(l))
		{
		int i;
		i=IntegerValue(ListFirst(l));
		if(i>in_prt+out_prt || i<-in_prt-out_prt)
			return 1;
		l=ListTail(l);
		}
	return 0;
	}
	

void write_moment(FILE *f, List l)
	{
	int ffl=1;
	while(!is_empty_list(l))
		{
		int pp;
		pp=IntegerValue(ListFirst(l));
		if(pp<0)
			{
			fprintf(f,"-");
			ffl=0;
			pp=-pp;
			}
		else
			{
			if(ffl==0)
				fprintf(f,"+");
			ffl=0;
			}
		if(pp<=in_prt+out_prt)
			fprintf(f,"p%d",pp);
		else
			fprintf(f,"q%d",pp-in_prt-out_prt);
			
		
		l=ListTail(l);
		}
	}

void wrt_vrt(Term d, FILE *f)
	{
	List l1,l2,l3,l4,l5;
	List fdiag;
	List prpp, prpq;
	int i,vno,pno;
	
	vi_as_ind=NewList();
	
	l1=CompoundArg2(d);
	
	
	
	fprintf(f,"OutSymFact:=");
	fWriteTerm(f,out_sym_fact);
	fprintf(f,"$\n");
	fprintf(f,"LoopSymFact:=");
	fWriteTerm(f,loop_sym_fact);
	fprintf(f,"$\n");
	
	if(vect_inds)
		{
		fprintf(f,"vector ");
		for(i=0;i<vect_inds;i++)
			{
			fprintf(f,"m%d",i+1);
			if(i==vect_inds-1)
				fprintf(f,"$\n");
			else
				fprintf(f,", ");
			}
		}
	fprintf(f,"vector ");
	for(i=0;i<in_prt+out_prt;i++)
		{
		fprintf(f,"p%d",i+1);
		if(i+1==in_prt+out_prt)
			fprintf(f,"$\n");
		else
			fprintf(f,", ");
		}
	fprintf(f,"p%d:=",in_prt+out_prt);
	for(i=0;i<in_prt;i++)
		{
		if(i) fprintf(f,"+");
		fprintf(f,"p%d",i+1);
		}
	for(i=0;i<out_prt-1;i++)
		fprintf(f,"-p%d",i+1+in_prt);
	fprintf(f,"$\n");
	if(loop_no)
		{
		fprintf(f,"vector ");
		for(i=0;i<loop_no;i++)
			{
			fprintf(f,"q%d",i+1);
			if(i==loop_no-1)
				fprintf(f,"$\n");
			else
				fprintf(f,", ");
			}
		}
			
	fprintf(f,"InPrtcls:=%d$\nOutPrtcls:=%d$\n",in_prt,out_prt);
	while(!is_empty_list(l1))
		{
		l2=CompoundArg1(ListFirst(l1));
		l3=CompoundArg2(ListFirst(l1));
		l4=CompoundArgN(ListFirst(l1),7);
		while(!is_empty_list(l2))
			{
			if(is_integer(ListFirst(l3)))
				{
				int st,sp;
				Atom prt;
				Term prp;
				Atom vi,mass;
				prt=ListFirst(l2);
				st=IntegerValue(ListFirst(l3));
				vi=ListFirst(l4);
				if(st<150)
					prt=GetAtomProperty(prt,A_ANTI);
				prp=GetAtomProperty(prt,PROP_TYPE);
				if(CompoundName(prp)!=OPR_PARTICLE)
					{
					puts("Unknown particle");
					exit(0);
					}
				sp=IntegerValue(CompoundArgN(prp,4));
				mass=CompoundArgN(prp,5);
				fprintf(f,"%sState(%d, \"%s\", %d, %cp%d, %s, %s)$\n",st>150?"Out":" In",
					st>150?st-200:st-100,AtomValue(prt),sp, 
					st<150?'-':' ', st>150?st-200+in_prt:st-100,  
					mass?AtomValue(mass):"0", vi?AtomValue(vi):"0");
				}
			l2=ListTail(l2);
			l3=ListTail(l3);
			l4=ListTail(l4);
			}
				
					 
		l1=ListTail(l1);
		}
	
	l1=CompoundArg2(d);
	i=0;
	fdiag=NewList();
	while(!is_empty_list(l1))
		{
		Term vrt;
		Term a2;
		int fr;
		i++;
		vrt=ListFirst(l1);
		a2=CompoundArgN(vrt,5);
		fr=alg2_rdc(a2,CompoundArgN(vrt,3),
			CompoundArgN(vrt,4),CompoundArgN(vrt,6));
		if(fr==0)
			fdiag=AppendLast(fdiag,NewInteger(i));
		fprintf(f,"Vrt%d:=\t",i);
		write_l_line(f,a2);
		l1=ListTail(l1);
		}
	fprintf(f,"AmplNum:=\tColorFactor*ComNumFact*ComSymFact");
	if(!is_empty_list(fdiag))
		{
		l1=fdiag;
		fprintf(f,"\n\t\t");
		while(!is_empty_list(l1))
			{
			fprintf(f,"*Vrt%d",(int)IntegerValue(ListFirst(l1)));
			l1=ListTail(l1);
			}
		FreeAtomic(fdiag);
		}
		
	if(p_vect)
		{
		l1=CompoundArg2(d);
		fprintf(f,"\n\t\t");
		while(!is_empty_list(l1))
			{
			l2=CompoundArg2(ListFirst(l1));
			l3=CompoundArgN(ListFirst(l1),4);
			l4=CompoundArgN(ListFirst(l1),7);
			while(!is_empty_list(l2))
				{
				if(is_integer(ListFirst(l2)) &&
				!is_empty_list(ListFirst(l3)))
					fprintf(f,"*%s.%s",
						AtomValue(ListFirst(ListFirst(l3))),
						AtomValue(ListFirst(l4)));
				l2=ListTail(l2);
				l3=ListTail(l3);
				l4=ListTail(l4);
				}
			l1=ListTail(l1);
			}
		}	
		
	i=0;
	vno=0;
	prpp=NewList();
	prpq=NewList();
	l1=CompoundArg2(d);
	while(!is_empty_list(l1))
		{
		vno++;
		l2=CompoundArg1(ListFirst(l1));
		l3=CompoundArg2(ListFirst(l1));
		l4=CompoundArgN(ListFirst(l1),3);
		l5=CompoundArgN(ListFirst(l1),4);
		
		pno=0;
		while(!is_empty_list(l2))
			{
			int vno1, pno1;
			List l51;
			Atom mass, width;
			int spin;
			Term prop;
			Term ppp;
			pno++;
			if(is_integer(ListFirst(l3)))
				goto cnt;
			vno1=IntegerValue(CompoundArg1(ListFirst(l3)));
			pno1=IntegerValue(CompoundArg2(ListFirst(l3)));
			if(vno1<vno || (vno1==vno && pno1<pno))
				goto cnt;
				
				
			l51=ListNth(CompoundArgN(ListNth(CompoundArg2(d),vno1),4),pno1);
			if(ListLength(l51)!=ListLength(ListFirst(l5)))
				{
				puts("Error l5-51");
				exit(0);
				}
			if(ListLength(l51)==2)
				{
				fprintf(f,"\n\t\t*%s.%s*%s.%s",
					AtomValue(ListFirst(ListFirst(l5))),
					AtomValue(ListFirst(l51)),
					AtomValue(ListNth(ListFirst(l5),2)),
					AtomValue(ListNth(l51,2))
					/*,vno,pno,vno1,pno1*/);
				goto cnt;
				}
			
			prop=GetAtomProperty(ListFirst(l2),PROP_TYPE);
			if(CompoundName(prop)!=OPR_PARTICLE)
				{
				puts("Unphisical particles not implemented");
				exit(0);
				}
			spin=IntegerValue(CompoundArgN(prop,4));
			mass=CompoundArgN(prop,5);
			width=CompoundArgN(prop,6);
			
			ppp=MakeCompound(A_I,3);
			SetCompoundArg(ppp,1,ListFirst(l4));
			SetCompoundArg(ppp,2,mass);
			SetCompoundArg(ppp,3,width);
			if(in_loop(ListFirst(l4)))
				prpq=AppendLast(prpq,ppp);
			else
				prpp=AppendLast(prpp,ppp);
			
			if(spin==2)
				{
				if(mass)
					{
					prpp=AppendFirst(prpp,mass);
					fprintf(f,"\n\t\t*(%s**2*%s.%s+%s.(",AtomValue(mass),
					AtomValue(ListFirst(ListFirst(l5))),
					AtomValue(ListFirst(l51)),
					AtomValue(ListFirst(l51)));
					write_moment(f,ListFirst(l4));
					fprintf(f,")*%s.(",AtomValue(ListFirst(ListFirst(l5))));
					write_moment(f,ListFirst(l4));
					fprintf(f,"))");
					}
				else
					{
					fprintf(f,"\n\t\t*%s.%s",
					AtomValue(ListFirst(ListFirst(l5))),
					AtomValue(ListFirst(l51)));
					}
				}
		cnt:
			l2=ListTail(l2);
			l3=ListTail(l3);
			l4=ListTail(l4);
			l5=ListTail(l5);
			}
		l1=ListTail(l1);
		}
		
	fprintf(f,"$\n");
		
	if(is_empty_list(prpp))
		fprintf(f,"AmplDenTree:=1$\n");
	else
		{
		l1=prpp;
		fprintf(f,"AmplDenTree:=");
		while(!is_empty_list(l1))
			{
			Term pp,m,w;
			if(is_atom(ListFirst(l1)))
				{
				fprintf(f,"\n\t%s**2",AtomValue(ListFirst(l1)));
				goto ccc;
				}
			pp=ConsumeCompoundArg(ListFirst(l1),1);
			m=CompoundArg2(ListFirst(l1));
			w=CompoundArgN(ListFirst(l1),3);
			fprintf(f,"\n\tP(");
			write_moment(f,pp);
			fprintf(f,",%s,%s)",m?AtomValue(m):"0",
				w?AtomValue(w):"0");
		ccc:
			l1=ListTail(l1);
			if(!is_empty_list(l1))
				fprintf(f,"*");
			else
				fprintf(f,"$\n");
			}
		FreeAtomic(prpp);
		}
	
	if(is_empty_list(prpq))
		fprintf(f,"AmplDenLoop:=1$\n");
	else
		{
		l1=prpq;
		fprintf(f,"AmplDenLoop:=");
		while(!is_empty_list(l1))
			{
			Term pp,m,w;
			pp=CompoundArg1(ListFirst(l1));
			m= CompoundArg2(ListFirst(l1));
			w= CompoundArgN(ListFirst(l1),3);
			fprintf(f,"\n\tP(");
			write_moment(f,pp);
			fprintf(f,",%s,%s)",m?AtomValue(m):"0",
				w?AtomValue(w):"0");

			l1=ListTail(l1);
			if(!is_empty_list(l1))
				fprintf(f,"*");
			else
				fprintf(f,"$\n");
			}
		if(loop_no==1)
			{
			fprintf(f,"xmom:=list(");
			l1=prpq;
			while(!is_empty_list(l1))
				{
				l2=CopyTerm(ConsumeCompoundArg(ListFirst(l1),1));
				l3=l2;
				while(!is_empty_list(l3))
					{
					int pp;
					pp=IntegerValue(ListFirst(l3));
					if(pp>in_prt+out_prt || -pp>in_prt+out_prt)
						{
						l2=CutFromList(l2,l3);
						break;
						}
					l3=ListTail(l3);
					}
				if(!is_empty_list(l2))
					write_moment(f,l2);
				else
					fprintf(f,"0");
				FreeAtomic(l2);
				l1=ListTail(l1);
				if(!is_empty_list(l1))
					fprintf(f,",");
				else
					fprintf(f,")$\n");
				}
				
			fprintf(f,"xmass:=list(");
			l1=prpq;
			while(!is_empty_list(l1))
				{
				Atom m;
				m=CompoundArg2(ListFirst(l1));
				fprintf(f,"%s",m?AtomValue(m):"0");
				l1=ListTail(l1);
				if(!is_empty_list(l1))
					fprintf(f,",");
				else
					fprintf(f,")$\n");
				}
			fprintf(f,"xwidth:=list(");
			l1=prpq;
			while(!is_empty_list(l1))
				{
				Atom m;
				m=CompoundArgN(ListFirst(l1),3);
				fprintf(f,"%s",m?AtomValue(m):"0");
				l1=ListTail(l1);
				if(!is_empty_list(l1))
					fprintf(f,",");
				else
					fprintf(f,")$\n");
				}
			}
		else
			{
			
			l1=prpq;
			while(!is_empty_list(l1))
				{
				ConsumeCompoundArg(ListFirst(l1),1);
				l1=ListTail(l1);
				}
			
			
			}
		FreeAtomic(prpq);
		}
		
	
				
	}
	
void end_diag(Term d, FILE *f)
	{
	
	int i;
	
	if(vect_inds)
		{
		fprintf(f,"indexlist := list(");
		for(i=0;i<vect_inds;i++)
			{
			fprintf(f,"m%d",i+1);
			if(i==vect_inds-1)
				fprintf(f,")$\n");
			else
				fprintf(f,", ");
			}
		}
	
	if(vi_as_ind)
		{
/*		fprintf(f,"index ");
		l=vi_as_ind;
		while(!is_empty_list(l))
			{
			fWriteTerm(f,ListFirst(l));
			l=ListTail(l);
			if(is_empty_list(l))
				fprintf(f,"$\n");
			else
				fprintf(f,", ");
			}*/
		FreeAtomic(vi_as_ind);
		vi_as_ind=NewList();
		}
	
	fprintf(f,"EndDiagr(%d)$\n",
		(int)IntegerValue(CompoundArg2(CompoundArg1(CompoundArg1(d)))));
		
	if(vect_inds)
		{
		fprintf(f,"clear ");
		for(i=0;i<vect_inds;i++)
			{
			fprintf(f,"m%d",i+1);
			if(i==vect_inds-1)
				fprintf(f,"$\n");
			else
				fprintf(f,", ");
			}
		}
	fprintf(f,"clear ");
	for(i=0;i<in_prt+out_prt;i++)
		{
		fprintf(f,"p%d",i+1);
		if(i+1==in_prt+out_prt)
			fprintf(f,"$\n");
		else
			fprintf(f,", ");
		}
	if(loop_no)
		{
		fprintf(f,"clear ");
		for(i=0;i<loop_no;i++)
			{
			fprintf(f,"q%d",i+1);
			if(i==loop_no-1)
				fprintf(f,"$\n");
			else
				fprintf(f,", ");
			}
		}
	
	}

static void write_l_line(FILE *f, Term a2)
	{
	int break_lines=1;
/*	if(GetAtomProperty(NewAtom("chepOutput",0),NewAtom("BreakLines",0)))
		break_lines=1;*/
		
	if(CompoundArg2(a2)==NewInteger(0) ||
		 is_empty_list(CompoundArgN(a2,5)))
			{
			fprintf(f,"0$\n");
			return;
			}
	
	
	
	{
	List s;
	int first=1;
	int w=0;
	int cf;
	s=CompoundArgN(a2,5);
	while(!is_empty_list(s))
		{
		Term m2;
		List lp,ls;
		int ast=0;
		m2=ListFirst(s);
		cf=IntegerValue(CompoundArg1(m2));
		lp=CompoundArg2(m2);
		ls=CompoundArgN(m2,3);
		if(!first && break_lines)
			{
			fprintf(f,"\n\t");
			}
		if(cf<0)
			{
			w+=fprintf(f,"-");
			cf=-cf;
			}
		else
			if(!first)
				 w+=fprintf(f,"+");
		first=0;
		if(cf!=1 || (is_empty_list(lp) && is_empty_list(ls)))
			{
			w+=fprintf(f,"%d",cf);
			ast=1;
			}
		while(!is_empty_list(lp))
			{
			int po;
			po=IntegerValue(CompoundArg2(ListFirst(lp)));
			if(ast)
				w+=fprintf(f,"*");
			else
				ast=1;
			w+=fprintf(f,"%s",AtomValue(CompoundArg1(ListFirst(lp))));
			if(po!=1)
				w+=fprintf(f,"**%d",po);
			lp=ListTail(lp);
			}
		while(!is_empty_list(ls))
			{
			if(ast)
				w+=fprintf(f,"*");
			else
				ast=1;
			w+=fprintf(f,"%s",AtomValue(ListFirst(ls)));
			ls=ListTail(ls);
			}
		s=ListTail(s);
		}
		
	}
	fprintf(f,"$\n");
	}		
	
